// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using TERASOLUNA.Fw.Web.Controller;

namespace TERASOLUNA.Fw.WebUT.Controller.Multipart
{
    ///<summary>
    /// MultipartItem StubNXłB
    ///</summary>

    class MultipartItemStub01 : MultipartItem
    {

        /// <summary>
        /// RXgN^łB
        /// </summary>
        /// <param name="boundary">Abv[hf[^؂邽߂̕łB</param>
        /// <param name="partStream">Abv[hꂽf[^łB</param>
        /// <param name="headerList">Abv[hf[^̃wb_łB</param>
        /// <param name="encoding">eLXgGR[h邽߂<seealso cref="Encoding"/>łB</param>
        public MultipartItemStub01(string boundary,
                                 Stream partStream,
                                 IDictionary<string, string> headerList,
                                 Encoding encoding)
            : base(boundary, partStream, headerList, encoding)
        {
        }


        /// <summary>
        /// i[Ăf[^eLXgǂ擾܂B
        /// </summary>
        /// <value>
        /// i[Ăf[^eLXgǂłB
        /// </value>
        public override bool IsText
        {
            get
            {
                return true;
            }
        }


        /// <summary>
        /// {fB̊Jnʒu\ʒu擾܂͐ݒ肵܂B
        /// </summary>
        /// <value>
        /// {fB̊Jnʒu\ʒułB
        /// </value>
        public long SetPositionStart
        {
            set
            {
                this.PositionStart = value;
            }
        }

        /// <summary>
        /// {fB̏Iʒu\ʒu擾܂͐ݒ肵܂B
        /// </summary>
        /// <value>
        /// {fB̏Iʒu\ʒułB
        /// </value>
        public long SetPositionEnd
        {
            set
            {
                this.PositionEnd = value;
            }
        }
        
        /// <summary>
        /// \[X܂B
        /// </summary>
        public override void Dispose()
        {
        }
    }
}
